diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
index ab847f4e2..a21b97e82 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlock.java
@@ -14,8 +14,8 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockContainer, Material, World, TileEntityPiston, 
-//            Block, PistonBlockTextures, AxisAlignedBB, IBlockAccess, 
+//            BlockContainer, Material, World, TileEntityPiston,
+//            Block, PistonBlockTextures, AxisAlignedBB, IBlockAccess,
 //            BlockEntity, Player
 
 public class MovingPistonBlock extends EntityBlock
@@ -80,7 +80,10 @@ public class MovingPistonBlock extends EntityBlock
     {
         if(!world.isClientSide && world.getBlockEntity(x, y, z) == null)
         {
-            world.setBlockWithNotify(x, y, z, 0);
+            int id = 0;
+            MovingPistonBlockEntity piston = getBlockEntity(world, x, y, z);
+            if (piston != null) id = piston.getMovedId();
+            world.setBlockWithNotify(x, y, z, id);
             return true;
         } else
         {
diff --git a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
index e03fe5436..e9406cf4d 100644
--- a/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/piston/MovingPistonBlockEntity.java
@@ -24,6 +24,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         this.direction = direction;
         this.extending = extending;
         this.isSourcePiston = isSourcePiston;
+        this.progress = this.progressO = 0.0F;
     }
 
     public int getMovedId()
@@ -126,15 +127,11 @@ public class MovingPistonBlockEntity extends BlockEntity
 
     public void finalTick()
     {
-        if(progressO < 1.0F)
-        {
-            progressO = progress = 1.0F;
-            worldObj.removeBlockTileEntity(x, y, z);
-            invalidate();
-            if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id)
-            {
-                worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
-            }
+        progressO = progress = 1.0F;
+        worldObj.removeBlockTileEntity(x, y, z);
+        invalidate();
+        if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id) {
+            worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
         }
     }
 
@@ -145,12 +142,7 @@ public class MovingPistonBlockEntity extends BlockEntity
         if(progressO >= 1.0F)
         {
             moveCollidedEntities(1.0F, 0.25F);
-            worldObj.removeBlockTileEntity(x, y, z);
-            invalidate();
-            if(worldObj.getBlockId(x, y, z) == Blocks.PISTON_MOVING.id)
-            {
-                worldObj.setBlockAndMetadataWithNotify(x, y, z, movedId, movedData);
-            }
+            finalTick();
             return;
         }
         progress += 0.5F;
diff --git a/src/main/java/net/minecraft/core/data/registry/Registries.java b/src/main/java/net/minecraft/core/data/registry/Registries.java
index f73bf4200..9b061abca 100644
--- a/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -10,6 +10,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.data.gamerule.GameRule;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.type.WorldType;
@@ -60,6 +61,7 @@ public class Registries extends Registry<Registry<?>>
         RECIPE_TYPES.register("minecraft:crafting/repairable_stackable", RecipeEntryRepairableStackable.class);
         RECIPE_TYPES.register("minecraft:crafting/uses_tool", RecipeEntryCraftingWithTool.class);
         RECIPE_TYPES.register("minecraft:crafting/map_duplication", RecipeEntryMapDuplication.class);
+        RECIPE_TYPES.register("minecraft:crafting/undyeing", RecipeEntryUndyeing.class);
         RECIPE_TYPES.register("minecraft:smelting", RecipeEntryFurnace.class);
         RECIPE_TYPES.register("minecraft:smelting/blast", RecipeEntryBlastFurnace.class);
         RECIPE_TYPES.register("minecraft:trommeling", RecipeEntryTrommel.class);
@@ -84,6 +86,50 @@ public class Registries extends Registry<Registry<?>>
         ITEM_GROUPS.register("minecraft:wools", stackListOf(new ItemStack(Blocks.WOOL, 1, 0), new ItemStack(Blocks.WOOL, 1, 1), new ItemStack(Blocks.WOOL, 1, 2), new ItemStack(Blocks.WOOL, 1, 3), new ItemStack(Blocks.WOOL, 1, 4), new ItemStack(Blocks.WOOL, 1, 5), new ItemStack(Blocks.WOOL, 1, 6), new ItemStack(Blocks.WOOL, 1, 7), new ItemStack(Blocks.WOOL, 1, 8), new ItemStack(Blocks.WOOL, 1, 9), new ItemStack(Blocks.WOOL, 1, 10), new ItemStack(Blocks.WOOL, 1, 11), new ItemStack(Blocks.WOOL, 1, 12), new ItemStack(Blocks.WOOL, 1, 13), new ItemStack(Blocks.WOOL, 1, 14), new ItemStack(Blocks.WOOL, 1, 15)));
         ITEM_GROUPS.register("minecraft:lamps", stackListOf(new ItemStack(Blocks.LAMP_IDLE, 1, 0), new ItemStack(Blocks.LAMP_IDLE, 1, 1), new ItemStack(Blocks.LAMP_IDLE, 1, 2), new ItemStack(Blocks.LAMP_IDLE, 1, 3), new ItemStack(Blocks.LAMP_IDLE, 1, 4), new ItemStack(Blocks.LAMP_IDLE, 1, 5), new ItemStack(Blocks.LAMP_IDLE, 1, 6), new ItemStack(Blocks.LAMP_IDLE, 1, 7), new ItemStack(Blocks.LAMP_IDLE, 1, 8), new ItemStack(Blocks.LAMP_IDLE, 1, 9), new ItemStack(Blocks.LAMP_IDLE, 1, 10), new ItemStack(Blocks.LAMP_IDLE, 1, 11), new ItemStack(Blocks.LAMP_IDLE, 1, 12), new ItemStack(Blocks.LAMP_IDLE, 1, 13), new ItemStack(Blocks.LAMP_IDLE, 1, 14), new ItemStack(Blocks.LAMP_IDLE, 1, 15)));
 
+        ITEM_GROUPS.register("minecraft:tool_swords",
+            stackListOf( // metadata of -1 to indicate that the metadata check should be skipped
+                new ItemStack(Items.TOOL_SWORD_WOOD, 1, -1),
+                new ItemStack(Items.TOOL_SWORD_STONE, 1, -1),
+                new ItemStack(Items.TOOL_SWORD_IRON, 1, -1),
+                new ItemStack(Items.TOOL_SWORD_GOLD, 1, -1),
+                new ItemStack(Items.TOOL_SWORD_DIAMOND, 1, -1),
+                new ItemStack(Items.TOOL_SWORD_STEEL, 1, -1)));
+
+        List<ItemStack> stackList = new ArrayList<>();
+        stackList.add(Blocks.STAIRS_PLANKS_OAK.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            stackList.add(new ItemStack(Blocks.STAIRS_PLANKS_PAINTED, 1, color.blockMeta << 4));
+        }
+        ITEM_GROUPS.register("minecraft:stairs_planks", stackList);
+
+        stackList = new ArrayList<>();
+        stackList.add(Blocks.SLAB_PLANKS_OAK.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            stackList.add(new ItemStack(Blocks.SLAB_PLANKS_PAINTED, 1, color.blockMeta << 4));
+        }
+        ITEM_GROUPS.register("minecraft:slabs_planks", stackList);
+
+        stackList = new ArrayList<>();
+        stackList.add(Blocks.FENCE_PLANKS_OAK.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            stackList.add(new ItemStack(Blocks.FENCE_PLANKS_OAK_PAINTED, 1, color.blockMeta));
+        }
+        ITEM_GROUPS.register("minecraft:fences_planks", stackList);
+
+        stackList = new ArrayList<>();
+        stackList.add(Blocks.FENCE_GATE_PLANKS_OAK.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            stackList.add(new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
+        }
+        ITEM_GROUPS.register("minecraft:fence_gates_planks", stackList);
+
+        stackList = new ArrayList<>();
+        stackList.add(Blocks.TRAPDOOR_PLANKS_OAK.getDefaultStack());
+        for (DyeColor color : DyeColor.values()) {
+            stackList.add(new ItemStack(Blocks.TRAPDOOR_PLANKS_PAINTED, 1, color.blockMeta << 4));
+        }
+        ITEM_GROUPS.register("minecraft:trapdoor_planks", stackList);
+
         if(RECIPES == null) new RecipeRegistry();
     }
 
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java b/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
index bcbbac3d7..748ce6e9d 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
@@ -42,23 +42,6 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         WORKBENCH.register("label",new RecipeEntryLabel());
         WORKBENCH.register("label_dye",new RecipeEntryLabelDye());
 
-        addCustomRecipe("minecraft:workbench/repair_chainmail_boots",       new RecipeEntryRepairable(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack(),        new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-        addCustomRecipe("minecraft:workbench/repair_chainmail_leggings",    new RecipeEntryRepairable(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack(),     new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-        addCustomRecipe("minecraft:workbench/repair_chainmail_chestplate",  new RecipeEntryRepairable(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack(),   new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-        addCustomRecipe("minecraft:workbench/repair_chainmail_helmet",      new RecipeEntryRepairable(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack(),       new RecipeSymbol(Items.CHAINLINK.getDefaultStack())));
-
-        addCustomRecipe("minecraft:workbench/scrap_chainmail_boots",        new RecipeEntryScrap(Items.ARMOR_BOOTS_CHAINMAIL,       Items.CHAINLINK));
-        addCustomRecipe("minecraft:workbench/scrap_chainmail_leggings",     new RecipeEntryScrap(Items.ARMOR_LEGGINGS_CHAINMAIL,    Items.CHAINLINK));
-        addCustomRecipe("minecraft:workbench/scrap_chainmail_chestplate",   new RecipeEntryScrap(Items.ARMOR_CHESTPLATE_CHAINMAIL,  Items.CHAINLINK));
-        addCustomRecipe("minecraft:workbench/scrap_chainmail_helmet",       new RecipeEntryScrap(Items.ARMOR_HELMET_CHAINMAIL,      Items.CHAINLINK));
-
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_wood",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_WOOD,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_stone",    new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_STONE,    new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_iron",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_IRON,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_gold",     new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_GOLD,     new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_diamond",  new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_DIAMOND,  new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-        addCustomRecipe("minecraft:workbench/carve_pumpkin_sword_steel",    new RecipeEntryCraftingWithTool(new ItemStack(Blocks.PUMPKIN), Items.TOOL_SWORD_STEEL,    new ItemStack(Blocks.PUMPKIN_CARVED_IDLE)));
-
         addCustomRecipe("minecraft:workbench/map_duplication", new RecipeEntryMapDuplication());
     }
 
@@ -267,17 +250,17 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         group.register(key,recipe);
     }
 
-    public static RecipeEntryCraftingShaped parseRecipe(ItemStack itemstack, boolean consumeContainerItem, Object... aobj) {
+    public static RecipeEntryCraftingShaped parseRecipe(ItemStack itemstack, boolean consumeContainerItem, boolean allowMirror, Object... aobj) {
         StringBuilder s = new StringBuilder();
         int i = 0;
-        int j = 0;
-        int k = 0;
+        int w = 0;
+        int h = 0;
         if(aobj[i] instanceof String[])
         {
             String[] as = (String[])aobj[i++];
             for (String s2 : as) {
-                k++;
-                j = s2.length();
+                h++;
+                w = s2.length();
                 s.append(s2);
             }
 
@@ -286,8 +269,8 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             while (aobj[i] instanceof String)
             {
                 String s1 = (String)aobj[i++];
-                k++;
-                j = s1.length();
+                h++;
+                w = s1.length();
                 s = new StringBuilder(s + s1);
             }
         }
@@ -318,8 +301,8 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             map.put(character, recipeSymbol);
         }
 
-        RecipeSymbol[] symbols = new RecipeSymbol[j * k];
-        for(int i1 = 0; i1 < j * k; i1++)
+        RecipeSymbol[] symbols = new RecipeSymbol[w * h];
+        for(int i1 = 0; i1 < w * h; i1++)
         {
             char c = s.charAt(i1);
             if(map.containsKey(c))
@@ -330,10 +313,10 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
                 symbols[i1] = null;
             }
         }
-        return new RecipeEntryCraftingShaped(j,k,symbols,itemstack,consumeContainerItem);
+        return new RecipeEntryCraftingShaped(w, h, symbols, itemstack, consumeContainerItem, allowMirror);
     }
 
-    public static RecipeEntryCraftingShaped parseRecipe(List<String> pattern, List<RecipeSymbol> symbols, ItemStack result, boolean consumeContainerItem) {
+    public static RecipeEntryCraftingShaped parseRecipe(List<String> pattern, List<RecipeSymbol> symbols, ItemStack result, boolean consumeContainerItem, boolean allowMirror) {
         Set<Character> chars = new HashSet<>();
         for (String s : pattern) {
             char[] chars1 = s.toCharArray();
@@ -352,7 +335,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             }
         }
         objs.add(0,pattern.toArray(new String[0]));
-        return parseRecipe(result,consumeContainerItem,objs.toArray());
+        return parseRecipe(result,consumeContainerItem, allowMirror,objs.toArray());
     }
 
     public void addShapelessRecipe(String recipeKey, ItemStack result, Object... ingredients) {
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index ae90a6116..9319c04ae 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -19,6 +19,13 @@ import java.lang.reflect.Type;
 
 public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSerializer<ItemStack> {
     private static final Logger LOGGER = LogUtils.getLogger();
+    public final boolean verbose;
+    public ItemStackJsonAdapter() {
+        this(false);
+    }
+    public ItemStackJsonAdapter(boolean verbose) {
+        this.verbose = verbose;
+    }
     @Override
     public ItemStack deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
         JsonObject obj = json.getAsJsonObject();
@@ -51,12 +58,15 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
             }
 
         }
-        if(obj.has("amount")){
-           stack = new ItemStack(item,obj.get("amount").getAsInt(),obj.get("meta").getAsInt());
-        } else {
-            stack = new ItemStack(item,1,obj.get("meta").getAsInt());
+        int amount = 1;
+        int meta = 0;
+        if (obj.has("amount")) {
+            amount = obj.get("amount").getAsInt();
         }
-        return stack;
+        if (obj.has("meta")) {
+            meta = obj.get("meta").getAsInt();
+        }
+        return new ItemStack(item, amount, meta);
     }
 
     @Override
@@ -64,8 +74,12 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
         JsonObject obj = new JsonObject();
 //        obj.addProperty("id",src.itemID); // Preferring namespace ids over integer ids for readability reasons
         obj.addProperty("id",src.getItem().namespaceID.toString());
-        obj.addProperty("amount",src.stackSize);
-        obj.addProperty("meta",src.getMetadata());
+        if (verbose || src.stackSize != 1) {
+            obj.addProperty("amount",src.stackSize);
+        }
+        if (verbose || src.getMetadata() != 0) {
+            obj.addProperty("meta",src.getMetadata());
+        }
         return obj;
     }
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
index 6bbce2c41..5cc1a36ee 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeCraftingShapedJsonAdapter.java
@@ -12,6 +12,9 @@ import java.util.ArrayList;
 import java.util.List;
 import java.util.stream.Collectors;
 
+import static net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped.DEFAULT_ALLOW_MIRROR;
+import static net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped.DEFAULT_CONSUME_CONTAINER;
+
 public class RecipeCraftingShapedJsonAdapter implements RecipeJsonAdapter<RecipeEntryCraftingShaped> {
 
     @Override
@@ -20,8 +23,9 @@ public class RecipeCraftingShapedJsonAdapter implements RecipeJsonAdapter<Recipe
         List<String> pattern = obj.get("pattern").getAsJsonArray().asList().stream().map(JsonElement::getAsString).collect(Collectors.toList());
         List<RecipeSymbol> symbols = obj.get("symbols").getAsJsonArray().asList().stream().map((E)->context.<RecipeSymbol>deserialize(E,RecipeSymbol.class)).collect(Collectors.toList());
         ItemStack result = context.deserialize(obj.get("result").getAsJsonObject(),ItemStack.class);
-        boolean consumeContainers = obj.get("consumeContainers").getAsBoolean();
-        return RecipeRegistry.parseRecipe(pattern,symbols,result,consumeContainers);
+        boolean consumeContainers = obj.has("consumeContainers") ? obj.get("consumeContainers").getAsBoolean() : DEFAULT_CONSUME_CONTAINER;
+        boolean mirror = obj.has("mirror") ? obj.get("mirror").getAsBoolean() : DEFAULT_ALLOW_MIRROR;
+        return RecipeRegistry.parseRecipe(pattern, symbols, result, consumeContainers, mirror);
     }
 
     @Override
@@ -65,7 +69,12 @@ public class RecipeCraftingShapedJsonAdapter implements RecipeJsonAdapter<Recipe
         obj.add("pattern",arr);
         obj.add("symbols",context.serialize(list));
         obj.add("result",context.serialize(src.getOutput()));
-        obj.addProperty("consumeContainers",src.consumeContainerItem);
+        if (src.consumeContainerItem != DEFAULT_CONSUME_CONTAINER) {
+            obj.addProperty("consumeContainers",src.consumeContainerItem);
+        }
+        if (src.allowMirrored != DEFAULT_ALLOW_MIRROR) {
+            obj.addProperty("mirror",src.allowMirrored);
+        }
         return obj;
     }
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryCraftingWithToolJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryCraftingWithToolJsonAdapter.java
new file mode 100644
index 000000000..4c384bf6b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryCraftingWithToolJsonAdapter.java
@@ -0,0 +1,36 @@
+package net.minecraft.core.data.registry.recipe.adapter;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingWithTool;
+import net.minecraft.core.item.ItemStack;
+
+import java.lang.reflect.Type;
+
+public class RecipeEntryCraftingWithToolJsonAdapter implements RecipeJsonAdapter<RecipeEntryCraftingWithTool> {
+    @Override
+    public RecipeEntryCraftingWithTool deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject object = json.getAsJsonObject();
+        RecipeSymbol input = context.deserialize(object.get("input"), RecipeSymbol.class);
+        RecipeSymbol tool = context.deserialize(object.get("tool"), RecipeSymbol.class);
+        ItemStack output = context.deserialize(object.get("output"), ItemStack.class);
+        return new RecipeEntryCraftingWithTool(input, tool, output);
+    }
+
+    @Override
+    public JsonElement serialize(RecipeEntryCraftingWithTool src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject object = new JsonObject();
+        object.addProperty("name",src.toString());
+        object.addProperty("type", Registries.RECIPE_TYPES.getKey(src.getClass()));
+
+        object.add("input", context.serialize(src.inputSymbol));
+        object.add("tool", context.serialize(src.toolToUse));
+        object.add("output", context.serialize(src.output));
+        return object;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryRepairableJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryRepairableJsonAdapter.java
new file mode 100644
index 000000000..79e9f4920
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryRepairableJsonAdapter.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.data.registry.recipe.adapter;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
+import net.minecraft.core.item.ItemStack;
+
+import java.lang.reflect.Type;
+
+public class RecipeEntryRepairableJsonAdapter implements RecipeJsonAdapter<RecipeEntryRepairable> {
+    @Override
+    public RecipeEntryRepairable deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject obj = json.getAsJsonObject();
+        ItemStack inputItem = context.deserialize(obj.get("input"), ItemStack.class);
+        RecipeSymbol repairMaterial = context.deserialize(obj.get("repairMaterial"), RecipeSymbol.class);
+        return new RecipeEntryRepairable(inputItem, repairMaterial);
+    }
+
+    @Override
+    public JsonElement serialize(RecipeEntryRepairable src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject object = new JsonObject();
+        object.addProperty("name",src.toString());
+        object.addProperty("type", Registries.RECIPE_TYPES.getKey(src.getClass()));
+
+        object.add("input", context.serialize(src.inItem));
+        object.add("repairMaterial", context.serialize(src.repairMaterial));
+        return object;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryScrapJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryScrapJsonAdapter.java
new file mode 100644
index 000000000..080319801
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryScrapJsonAdapter.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.data.registry.recipe.adapter;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
+import net.minecraft.core.item.ItemStack;
+
+import java.lang.reflect.Type;
+
+public class RecipeEntryScrapJsonAdapter implements RecipeJsonAdapter<RecipeEntryScrap> {
+    @Override
+    public RecipeEntryScrap deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject obj = json.getAsJsonObject();
+        ItemStack input = context.deserialize(obj.get("input").getAsJsonObject(),ItemStack.class);
+        ItemStack scrapItem = context.deserialize(obj.get("output").getAsJsonObject(),ItemStack.class);
+        int maxYield = obj.get("maxYield").getAsInt();
+        return new RecipeEntryScrap(input.getItem(), scrapItem.getItem(), maxYield);
+    }
+
+    @Override
+    public JsonElement serialize(RecipeEntryScrap src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject object = new JsonObject();
+        object.addProperty("name",src.toString());
+        object.addProperty("type", Registries.RECIPE_TYPES.getKey(src.getClass()));
+
+        object.add("input", context.serialize(new ItemStack(src.itemToScrap)));
+        object.add("output", context.serialize(new ItemStack(src.scrapYield)));
+        object.addProperty("maxYield", src.maxYield);
+        return object;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryUndyeingJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryUndyeingJsonAdapter.java
new file mode 100644
index 000000000..bc736362d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryUndyeingJsonAdapter.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.data.registry.recipe.adapter;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+import net.minecraft.core.item.ItemStack;
+
+import java.lang.reflect.Type;
+
+public class RecipeEntryUndyeingJsonAdapter implements RecipeJsonAdapter<RecipeEntryUndyeing>{
+    @Override
+    public RecipeEntryUndyeing deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject obj = json.getAsJsonObject();
+        RecipeSymbol input = context.deserialize(obj.get("input"), RecipeSymbol.class);
+        ItemStack output = context.deserialize(obj.get("output"), ItemStack.class);
+        return new RecipeEntryUndyeing(input, output);
+    }
+
+    @Override
+    public JsonElement serialize(RecipeEntryUndyeing src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject object = new JsonObject();
+        object.addProperty("name",src.toString());
+        object.addProperty("type", Registries.RECIPE_TYPES.getKey(src.getClass()));
+
+        object.add("input", context.serialize(src.inputSymbol));
+        object.add("output", context.serialize(src.output));
+        return object;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeSymbolJsonAdapter.java b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeSymbolJsonAdapter.java
index f6578cec0..9a001cee9 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeSymbolJsonAdapter.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeSymbolJsonAdapter.java
@@ -7,6 +7,13 @@ import net.minecraft.core.item.ItemStack;
 import java.lang.reflect.Type;
 
 public class RecipeSymbolJsonAdapter implements JsonDeserializer<RecipeSymbol>, JsonSerializer<RecipeSymbol> {
+    public final boolean verbose;
+    public RecipeSymbolJsonAdapter() {
+        this(false);
+    }
+    public RecipeSymbolJsonAdapter(boolean verbose) {
+        this.verbose = verbose;
+    }
     @Override
     public RecipeSymbol deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
         JsonObject obj = json.getAsJsonObject();
@@ -32,16 +39,16 @@ public class RecipeSymbolJsonAdapter implements JsonDeserializer<RecipeSymbol>,
     @Override
     public JsonElement serialize(RecipeSymbol src, Type typeOfSrc, JsonSerializationContext context) {
         JsonObject obj = new JsonObject();
-        if(src.getSymbol() != 0){
+        if(verbose || src.getSymbol() != 0){
             obj.addProperty("symbol",src.getSymbol());
         }
-        if(src.getItemGroup() != null) {
+        if(verbose || src.getItemGroup() != null) {
             obj.addProperty("group",src.getItemGroup());
         }
-        if(src.getAmount() != 1){
+        if(verbose || src.getAmount() != 1){
             obj.addProperty("amount",src.getAmount());
         }
-        if(src.getStack() != null){
+        if(verbose || src.getStack() != null){
             obj.add("stack",context.serialize(src.getStack()));
         }
         return obj;
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
index 3d9b181bd..e50fe88a7 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryCrafting.java
@@ -23,7 +23,7 @@ public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void>
         return false;
     }
 
-    public abstract boolean matches(CraftingContainer inventorycrafting);
+    public abstract boolean matches(CraftingContainer craftingContainer);
 
     public boolean matchesQueryIgnoreExceptions(SearchQuery query){
         try {
@@ -35,9 +35,9 @@ public abstract class RecipeEntryCrafting<I,O> extends RecipeEntryBase<I,O,Void>
 
     public abstract boolean matchesQuery(SearchQuery query);
 
-    public abstract ItemStack getCraftingResult(CraftingContainer inventorycrafting);
+    public abstract ItemStack getCraftingResult(CraftingContainer craftingContainer);
 
     public abstract int getRecipeSize();
 
-    public abstract ItemStack[] onCraftResult(CraftingContainer inventorycrafting);
+    public abstract ItemStack[] onCraftResult(CraftingContainer craftingContainer);
 }
